// пример с "бегущей радугой" для библиотеки FastLED
#define NUM_LEDS 54
#define auto_bright 1        // автоматическая подстройка яркости от уровня внешнего освещения (1 - включить, 0 - выключить)
#define max_bright 255       // максимальная яркость (0 - 255)
#define min_bright 10        // минимальная яркость (0 - 255)
#define bright_constant 300  // константа усиления от внешнего света (0 - 1023)
// чем МЕНЬШЕ константа, тем "резче" будет прибавляться яркость
//----------------------НАСТРОЙКИ-----------------------

int new_bright;
int val;

unsigned long bright_timer;
#include "FastLED.h"
#define PIN 6

CRGB leds[NUM_LEDS];
byte counter;
void setup() {
  FastLED.addLeds<WS2811, PIN, GRB>(leds, NUM_LEDS).setCorrection( TypicalLEDStrip );
  FastLED.setBrightness(50);
  pinMode(13, OUTPUT);
  Serial.begin(1000000);
}
void loop() {
  if (auto_bright) {                         // если включена адаптивная яркость
    if (millis() - bright_timer > 1) {     // каждые 1 мс
      bright_timer = millis();               // сброить таймер
      val = (analogRead(2) + analogRead(3) + analogRead(4) + analogRead(5)) / 4;
      val = (val + analogRead(2) + analogRead(3) + analogRead(4) + analogRead(5)) / 5;
      val = (val + analogRead(2) + analogRead(3) + analogRead(4) + analogRead(5)) / 5;
      val = (val + analogRead(2) + analogRead(3) + analogRead(4) + analogRead(5)) / 5;
      val = (val + analogRead(2) + analogRead(3) + analogRead(4) + analogRead(5)) / 5;
      val = (val + analogRead(2) + analogRead(3) + analogRead(4) + analogRead(5)) / 5;
      val = (val + analogRead(2) + analogRead(3) + analogRead(4) + analogRead(5)) / 5;




      


      new_bright = map(val, 0, bright_constant, min_bright, max_bright);   // считать показания с фоторезистора, перевести диапазон
      new_bright = constrain(new_bright, min_bright, max_bright);
      LEDS.setBrightness(new_bright);        // установить новую яркость


      Serial.print(val);
      Serial.print("  ");
      Serial.print(analogRead(2));
      Serial.print("  ");
      Serial.print(analogRead(3));
      Serial.print("  ");
      Serial.print(analogRead(4));
      Serial.print("  ");
      Serial.println(analogRead(5));
    }
  }

  for (int i = 0; i < NUM_LEDS; i++ ) {         // от 0 до первой трети
    leds[i] = 0xFFfffF; //CHSV(255, 255, 255);  // HSV. Увеличивать HUE (цвет)
    // умножение i уменьшает шаг радуги
  }
  counter++;        // counter меняется от 0 до 255 (тип данных byte)
  FastLED.show();
  // delay(10);         // скорость движения радуги
}
